/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.baselibs;

import cdac.medinfo.sdk.dcm30_04.commoninterface.IDataElement;
import cdac.medinfo.sdk.dcm30_04.commoninterface.IDictionaryReader;
import cdac.medinfo.sdk.dcm30_04.commoninterface.ITransferSyntax;
import cdac.medinfo.sdk.dcm30_04.exceptions.ConditionFailedException;
import cdac.medinfo.sdk.dcm30_04.exceptions.InvalidItemException;
import cdac.medinfo.sdk.dcm30_04.exceptions.MandatoryMissingException;
import cdac.medinfo.sdk.dcm30_04.exceptions.ValidationException;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConfig;
import cdac.medinfo.sdk.dcm30_04.utils.DicomConstants;
import cdac.medinfo.sdk.dcm30_04.utils.DicomLogger;
/**
* This item class contains methods to validate, set and get the attributes of Projection Pixel Calibration Sequence.
 */


public class ProjectionPixelCalibrationSequenceItem extends Item
{
	


	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * This constructor creates the item with default TransferSyntax 
	 */
	ProjectionPixelCalibrationSequenceItem()
	{
		super();
	}

	/*
	 * This constructor calls the respective superclass constructor
	 * This constructor should throw exception if null TS is tried to be set
	 */
	/**
	 * This constructor creates the item with specified TransferSyntax 
	 * and default DictionaryReader
	 * @param objITransferSyntax specifies the DICOM Standard defined TransfeSyntax
	 */
	ProjectionPixelCalibrationSequenceItem(ITransferSyntax objITransferSyntax)
	{
		super(objITransferSyntax);
	}

	/**
	 * This constructor creates ProjectionPixelCalibrationSequenceItem with specified TransferSyntax and
	 * specified DictionaryReader.
	 * @param objTransferSyntax specifies the DICOM Standard defined TransfeSyntax.
	 * @param objDictionaryReader specifies the DICOM Dictionary reader to be used.
	 */
	ProjectionPixelCalibrationSequenceItem(ITransferSyntax objTransferSyntax, IDictionaryReader objDictionaryReader)
	{
		super(objTransferSyntax,objDictionaryReader);
	}

	/*
	 * (non-Javadoc) This method validates the contents of the Item
	 * @see cdac.medinfo.sdk.dcm30_04.commoninterface.IItem#validate()
	 */
	/**
	 * Validates all the attributes in ProjectionPixelCalibrationSequenceItem that are present in the DataSet
	 * @return boolean - Success -true, Failure - false
	 * @throws InvalidItemException throws InvalidItemException If Mandatory or Conditional element fails.
	 */
	public boolean validateForModule()  throws InvalidItemException
	{
		try{
			if(!contains(0x0018,0x9403))
				throw new MandatoryMissingException("0018,9403");
			if(getDataForTag(0x0018,0x9403).getValue()!=null)
				if(!contains(0x0018,0x9404))
					throw new ConditionFailedException("0x0018,0x9404");
		}
		catch(MandatoryMissingException me)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(me.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),me);
		}
		catch(ConditionFailedException ce)
		{
			if(DicomConfig.createInstance().isLoggingOn())
			{
				DicomLogger.getLogger().log(ce.getMessage());
			}
			throw new ValidationException(this.getClass().getSimpleName(),ce); 
		}
		return true;
	}
	
	/**
	 * Sets the Distance Object to Table Top.
	 * Distance between the anatomic region of interest of observation and table top in mm.
	 * @param fDistanceObjecttoTableTop Float value of the Distance Object to Table Top
	 */
	public void setDistanceObjecttoTableTop( float fDistanceObjecttoTableTop)
	{
		/*
		 * Accept the Distance Object to Table Top in String format of type FL.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)	
			objIDataElement = new ImplicitDE(0x0018,0x9403, fDistanceObjecttoTableTop,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0018,0x9403,DicomConstants.DCM_DT_FL, fDistanceObjecttoTableTop);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves the Distance Object to Table Top.
	 * Distance between the anatomic region of interest of observation and table top in mm.
	 * @return float - Float value of the Distance Object to Table Top
	 */
	public float getDistanceObjecttoTableTop()
	{
		Object objValue = getValue(0x0018,0x9403);
		if(objValue != null)
			return Float.parseFloat(objValue.toString());
		return DicomConstants.DCM_NO_VALUE;
	}
	
	/**
	 * Sets a Object Pixel Spacing in Center of Beam.
	 * @param arrFObjectPixelSpacinginCenterofBeam pair of Object Pixel Spacing in Center of Beam
	 */
	public void setObjectPixelSpacinginCenterofBeam(float[] arrFObjectPixelSpacinginCenterofBeam)
	{
		/* Accept the Object Pixel Spacing in Center of Beam in short format of type FL.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0018,0x9404, arrFObjectPixelSpacinginCenterofBeam,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0018,0x9404,DicomConstants.DCM_DT_FL, arrFObjectPixelSpacinginCenterofBeam);

		addDataElement(objIDataElement);
	}

	/**
	 * Retrieves Object Pixel Spacing in Center of Beam.
	 * @return float[] - Float array of Object Pixel Spacing in Center of Beam.
	 */
	public float[] getObjectPixelSpacinginCenterofBeam()
	{
		Object objValue = getValue(0x0018,0x9404);
		if(objValue != null)
			return (float[])objValue;
		return null;
	}
	
	/**
	 * Sets Table Height.
	 * @param strTableHeight String value of Table Height.
	 */
	public void setTableHeight(String strTableHeight)
	{
		/*Accept the Table Height in String format of type DS.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)
			objIDataElement = new ImplicitDE(0x0018,0x1130, strTableHeight,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0018,0x1130,DicomConstants.DCM_DT_DS, strTableHeight);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves Table Height.
	 * @return String - value of Table Height.
	 */
	public String getTableHeight()
	{
		Object objValue = getValue(0x0018,0x1130);
		if(objValue != null)
			return objValue.toString();
		return null;
	}
	
	/**
	 * Sets the Beam Angle.
	 * @param fBeamAngle Float value of Beam Angle
	 */
	public void setBeamAngle( float fBeamAngle)
	{
		/*
		 * Accept the Beam Angle in String format of type FL.
		 * Read the Transfer Syntax and check if ImplicitDE or ExplicitDE to create
		 * Set the iGroupNumber and iElementNumber to ImplicitDE object 
		 * Set the iVRType
		 * Set length from the element
		 * Add this element to the Data Set
		 */
		IDataElement objIDataElement = null;
		if(objITransferSyntax.getVRTransferSyntax() == DicomConstants.DCM_VR_IMPLICIT)	
			objIDataElement = new ImplicitDE(0x0018,0x9449, fBeamAngle,getDictionaryReader());
		else
			objIDataElement = new ExplicitDE(0x0018,0x9449,DicomConstants.DCM_DT_FL, fBeamAngle);

		addDataElement(objIDataElement);
	}
	/**
	 * Retrieves the Beam Angle.
	 * @return float - Float value of the Beam Angle
	 */
	public float getBeamAngle()
	{
		Object objValue = getValue(0x0018,0x9449);
		if(objValue != null)
			return Float.parseFloat(objValue.toString());
		return DicomConstants.DCM_NO_VALUE;
	}
}
